/**
 * me
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
var me = {};

me.resize = {
    resizeMinWidth : 600,
    resizeMinHeight : 300,
    resizeBox : function(targetId)
    {
        var resizeTarget = $('#' + targetId);
        var setHeight = $(window).height() - ($('body').height() - resizeTarget.height()) - 3;
        if (setHeight < me.resize.resizeMinHeight) {
            setHeight = me.resize.resizeMinHeight;
        }
        var setWidth = $(window).width() - (resizeTarget.offset().left + 20) - 3;
        if (setWidth < me.resize.resizeMinWidth) {
            setWidth = me.resize.resizeMinWidth;
        }
        resizeTarget.height(setHeight);
        resizeTarget.width(setWidth);
    }
}

me.form = {
    unloadFlag : true,
    init : function()
    {
        window.onbeforeunload = function(){
            if (!me.form.unloadFlag) {
                return;
            }
            $.ajax({
                type: 'GET',
                async: false,
                url: '../Main/unset_form?_form_id=' + $('#_form_id').val(),
                success: function(html){
                },
                error: function(XHR, textStatus, errorThrown){
                    me.error.ajaxError(XHR, textStatus, errorThrown);
                }
            });
        }
    },
    noUnload : function()
    {
        me.form.unloadFlag = false;
    }
}

me.error = {
    ajaxError : function(XHR, textStatus, errorThrown){
        var message = $(XHR.responseText).find('#message').text();
        if (message == '') {
            message = textStatus;
        }
        alert(message);
    },
    htmlError : function()
    {
        if (window.frameElement) {
            // iframe
            var message = $('#message').text();
            if (message == '') {
                message = 'error';
            }
            alert(message);
        }
    }
}

me.help = {
    open : function(help_page)
    {
        help_page = (!help_page) ? 'index.html' : help_page;

        if ($('#help_box').get(0)) {
            if ($('#help_box').is(':visible')) {
                $('#help_box').hide();
            } else {
                $('#help_box').show();
                me.help.resize();
                $('body').one('mousedown', function(){
                    me.help.close();
                });
            }
        } else {
            $.ajax({
                type: 'GET',
                url: '../Help/index?p=' + help_page,
                success: function(html){
                    $(html).appendTo('body');
                    me.help.resize();
                    $(window).bind('resize', function(){
                        me.help.resize();
                    });
                    $('body').one('mousedown', function(){
                        me.help.close();
                    });
                    $('#help_box, #help_button').bind('mousedown', function(event){
                        event.stopPropagation();
                    });
                },
                error: function(XHR, textStatus, errorThrown){
                    me.error.ajaxError(XHR, textStatus, errorThrown);
                }
            });
        }
    },
    close : function()
    {
        if ($('#help_box').is(':visible')) {
            $('#help_box').hide();
        }
    },
    go : function(help_page)
    {
        help_page = (!help_page) ? 'index.html' : help_page;
        if ($('#help_iframe').get(0)) {
            $('#help_iframe')[0].contentWindow.location.href = '../Help/read?p=' + help_page;
            $('#help_box').show();
        } else {
            me.help.open(help_page);
        }
        $('body').one('mousedown', function(){
            me.help.close();
        });
    },
    resize : function()
    {
        var offset = $('#help_button').offset();
        offset.top += $('#help_button').height() + 20;

        var left = ($(window).width() > 780) ? ($(window).width() - 630) : 50;
        var height = $(window).height() - offset.top - 100;
        height = (height < 300) ? 300 : height;
        $('#help_box').css({
            'top': offset.top,
            'left': left
        });
        $('#help_iframe').height(height);
    },
    openNewTab : function()
    {
        window.open($('#help_iframe')[0].contentWindow.location.href);
    }
}