/**
 * me.page
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */

me.page = {
    tempElementId : null,
    tempElement : null,
    currentHref : null,
    scrollTop : 0,
    init : function()
    {
        $('#edit_iframe').get(0).contentWindow.onload = function (){
            me.page.checkIframe();
        }
        if ($('#error_message').text().length > 0) {
            me.page.openPageSetting();
        }
        if ($('#file_name').is('*')) {
            me.page.resizeFileName();
            $('#file_name').bind('blur', function(e){
                me.page.resizeFileName();
            });
        }
    },
    initEditBox : function(id, thisObj)
    {
        me.page.close();
        me.page.tempElementId = id;
        me.page.tempElement = thisObj;
    },
    open : function(id, thisObj, type, repeatId, repeatNo)
    {
        me.page.initEditBox(id, thisObj);
        $.ajax({
            type: 'POST',
            url: '../Page/open',
            data: ({
                'id' : id,
                'repeat_id' : repeatId,
                'repeat_no' : repeatNo,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                var position = me.page.getPosition(thisObj);

                $(html).appendTo('body').draggable({
                    'containment' : '#edit_iframe_box',
                    'cancel' : ':input, .nicEdit-main'
                    
                });
                $('.me_editor').css({
                    top: position.top +'px',
                    left: position.left + 'px',
                    position:'absolute'
                });
                $('#toolbar_box').append($('#toolbar_html'));
                $('#node_value').focus();
                var method_name = type.substr(0,1).toUpperCase() + type.substr(1,type.length);
                eval('me.page.open' + method_name + '();');
                me.resize.resizeBox('edit_iframe');
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    openText : function()
    {
    },
    openTextarea : function()
    {
    },
    openRich : function()
    {
        new nicEditor({
            iconsPath : '../../app/assets/images/nicedit/nicEditorIcons.gif',
            maxHeight : 400,
            buttonList : ['bold', 'italic', 'underline', 'strikethrough', 'forecolor', 'removeformat', 'link', 'unlink', 'xhtml']
        }).panelInstance('node_value');
        $('.nicEdit-main').focus();
    },
    openDate : function()
    {
        var defaultValue = ($('#node_value').val() != '') ? $('#node_value').val() : null ;
        var date = Date.parse(defaultValue);
        if (isNaN(date)) {
            defaultValue = null;
        }

        $.datepicker.setDefaults( $.datepicker.regional['ja'] );
        $('#datepicker').datepicker({
            defaultDate: defaultValue,
            dateFormat: 'yy-mm-dd',
            onSelect: function(dateText) {
                $('#node_value').val(dateText);
            }
        });
    },
    openImg : function()
    {
    },
    openSource : function()
    {
    },
    reflect : function()
    {
        var iframeDoc = $('#hidden_iframe')[0].contentWindow.document;
        var html = iframeDoc.body.innerHTML;
        $(me.page.tempElement).replaceWith(html);
        iframeDoc.open();
        iframeDoc.close();
        me.page.close();
    },
    close : function()
    {
        $('.me_editor').remove();
        $('.ui-datepicker').remove();
        $('#toolbar_box').empty();
    },
    getPosition : function(thisObj)
    {
        var iframeDoc = $('#edit_iframe')[0].contentWindow.document;
        var parentBody = $(window);

        // top position
        var bodyScrollTop = parentBody.scrollTop();
        var iframeScrollTop = $(iframeDoc).scrollTop();
        var setTop = $("#edit_iframe").offset().top + $(thisObj).offset().top;

        // left position
        var bodyScrollLeft = parentBody.scrollLeft();
        var iframeScrollLeft = $(iframeDoc).scrollLeft();
        var setLeft = $("#edit_iframe").offset().left + $(thisObj).offset().left;

        if ($.browser.msie) {
            setLeft -= iframeScrollLeft;
            setTop -= iframeScrollTop;
        } else {
            setLeft -= bodyScrollLeft;
            setTop -= bodyScrollTop;
            if (bodyScrollLeft == 0) {
                setLeft -= iframeScrollLeft;
            }
            if (bodyScrollTop == 0) {
                setTop -= iframeScrollTop;
            }
        }

        return {
            left: setLeft,
            top: setTop
        };
    },
    openRepeat : function()
    {
        if ($('#toolbar_repeat').is(':hidden')) {
            $('.toolbar_option').hide();
            var offset = $('#toolbar_box').offset();
            offset.top += $('#toolbar_box').height();
            $('#toolbar_repeat').css({
                position:'absolute',
                top: offset.top + 'px',
                left: offset.left + 'px'
            }).show();
        } else {
            $('#toolbar_repeat').hide();
        }
    },
    handlingRepeat : function(command, repeatId, repeatNo)
    {
        me.page.scrollTop = $('#edit_iframe')[0].contentWindow.document.documentElement.scrollTop;
        $.ajax({
            type: 'POST',
            url: '../Page/handling_repeat',
            data: ({
                'command' : command,
                'repeat_id' : repeatId,
                'repeat_no' : repeatNo,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                me.page.close();
                var iframeDoc = $('#edit_iframe')[0].contentWindow.document;
                iframeDoc.open();
                iframeDoc.write(html);
                iframeDoc.close();
                iframeDoc.documentElement.scrollTop = me.page.scrollTop;
                me.page.checkIframe();
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    openLink : function()
    {
        if ($('#toolbar_link').is(':hidden')) {
            $('.toolbar_option').hide();
            var offset = $('#toolbar_box').offset();
            offset.top += $('#toolbar_box').height();
            $('#toolbar_link').css({
                position:'absolute',
                top: offset.top + 'px',
                left: offset.left + 'px'
            }).show();
        } else {
            $('#toolbar_url').val($('#url').val());
            $('#toolbar_target').val($('#target').val());
            $('#toolbar_link').hide();
        }
    },
    applyLink : function()
    {
        $('#url').val($('#toolbar_url').val());
        $('#target').val($('#toolbar_target').val());
        $('#toolbar_link').hide();
    },
    openSelectPage : function()
    {
        if ($('.select_page').is(':has(*)')) {
            $('.select_page').empty();
        } else {
            me.page.selectPage('');
        }
    },
    selectPage : function(dir)
    {
        if (dir == null || dir == '') {
            dir = '/';
        }

        $.ajax({
            type: 'POST',
            url: '../Page/select_page',
            data: ({
                'dir' : dir,
                '_form_id' : $('#_form_id').val(),
                '_token' : $('#_token').val()
            }),
            success: function(html){
                $('.select_page').empty().append(html);
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    setLink : function(url)
    {
        $('#toolbar_url').val(url);
        $('.select_page').empty();
    },
    openAnchor : function()
    {
        if ($('#toolbar_anchor_box').is(':hidden')) {
            $('.toolbar_option').hide();
            var offset = $('#toolbar_box').offset();
            offset.top += $('#toolbar_box').height();
            $('#toolbar_anchor_box').css({
                position:'absolute',
                top: offset.top + 'px',
                left: offset.left + 'px'
            }).show();
        } else {
            $('#toolbar_anchor').val($('#anchor').val());
            $('#toolbar_anchor_box').hide();
        }
    },
    applyAnchor : function()
    {
        $('#anchor').val($('#toolbar_anchor').val());
        $('#toolbar_anchor_box').hide();
    },
    checkIframe : function()
    {
        $("#edit_iframe").contents().find('a,form').not('.metag > *').bind('click', function(e){
            e.preventDefault();
        });
        me.page.currentHref = $('#edit_iframe')[0].contentWindow.location.href;
        setInterval(me.page.checkHref, 100);
    },
    checkHref : function()
    {
        if (me.page.currentHref != $('#edit_iframe')[0].contentWindow.location.href) {
            $('#edit_iframe')[0].contentWindow.history.back();
        }
    },
    resizeFileName : function()
    {
        var size = ($('#file_name').val().length > 0) ? $('#file_name').val().length : 10;
        $('#file_name').attr('size', size);
        $.ajax({
            type: 'POST',
            url: '../Page/check_file_name',
            data: $('#page_edit_form').serialize(),
            success: function(html){
                $('#file_name_message').empty().append(html);
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
    },
    openPageSetting : function()
    {
        $('.page_setting,#close_page_setting').show();
        $('#open_page_setting').hide();
        me.resize.resizeBox('edit_iframe');
    },
    closePageSetting : function()
    {
        $('.page_setting,#close_page_setting').hide();
        $('#open_page_setting').show();
        me.resize.resizeBox('edit_iframe');
    },
    preview : function()
    {
        $.ajax({
            type: 'POST',
            async: false,
            url: '../Page/update_header',
            data: $('#page_edit_form').serialize(),
            success: function(html){
            },
            error: function(XHR, textStatus, errorThrown){
                me.error.ajaxError(XHR, textStatus, errorThrown);
            }
        });
        window.open('../Page/preview?_form_id=' + $('#_form_id').val());
    },
    submit : function()
    {
        $('#page_edit_form').trigger('submit');
    }
};