<?php
/**
 * DB管理
 * @package     Me
 * @copyright   Copyright (C) 2011 MicroEngine Inc.
 */
class Me_Db
{
    /**
     * PDOインスタンスを格納
     * @var object PDO
     */
    private static $pdo_instance;

    /**
     * コンストラクタ
     */
    private function __construct()
    {

    }

    /**
     * PDOインスタンス取得
     * @param string $db_name DB名
     * @return object $pdo_instance
     */
    public static function get_pdo_instance($db_name = 'cms')
    {
        if (self::$pdo_instance == null) {
            self::db_open($db_name);
        }
        return self::$pdo_instance;
    }

    /**
     * データベースハンドル生成
     * @param string $db_name DB名
     */
    private static function db_open($db_name = 'cms')
    {
        $dsn = 'sqlite:' . DATA_ROOT . '/db/' . $db_name . '.db';
        try {
            self::$pdo_instance = new PDO($dsn);
            self::$pdo_instance->beginTransaction();
            self::$pdo_instance->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        } catch (PDOException $e) {
            throw new Me_Exception(200, array($e->getMessage()));
            exit;
        } catch (Exception $e) {
            throw new Me_Exception(200, array($e->getMessage()));
            exit;
        }
    }

    /**
     * コミット処理
     */
    public static function commit()
    {
        if (self::$pdo_instance != null) {
            self::$pdo_instance->commit();
        }
    }
}